*	TITLE	'8 x 12 MATRIX CHARACTER GENERATOR'
*
*	Copyright (c) 1982,1985,1989  Lindley Systems
*
*	Copy for personal use of the purchaser is authorized;
*	copy for any other use is prohibited.
*
*	Produces packed file of 8X12 Graphics.
*
*	06/16/85
*
USERFWA EQU	042200A
$UDD	EQU	31157A
$MU86	EQU	031007A (A)*(D,E)->(H,L)
$DADA	EQU	30072A
$DADA.	EQU	030101A ADD A TO H,L
$CDEHL	EQU	030173A Z SET IF C,D = H,L
$TYPTX	EQU	31136A
$SAVALL EQU	31054A
$RSTALL EQU	31047A
TAB	EQU	9
ESC	EQU	27
NL	EQU	10
ENL	EQU	138
I.CONWI EQU	3A
.EXIT	EQU	0A
.SCIN	EQU	1A
.SCOUT	EQU	2A
.READ	EQU	4A
.WRITE	EQU	5A
.CONSL	EQU	6A
.CLRCO	EQU	7A
.CTLC	EQU	41A
.OPENR	EQU	42A
.OPENW	EQU	43A
.CLOSE	EQU	46A
**
*
GOTOIT	ORG	USERFWA

	CALL	$TYPTX
	DB	ESC,'x1',ESC,'x7',ESC,'y4',ENL
	XRA	A
	MVI	B,201Q	CHARACTER MODE, NO ECHO
	MVI	C,201Q
	SCALL	.CONSL
	MVI	A,3	SET CTL-C EXIT
	LXI	H,CCXIT
	SCALL	.CTLC
	MVI	A,I.CONWI ELIMINATE AUTO NEW LINE
	MVI	B,377Q
	MVI	C,377Q
	SCALL	.CONSL
	SCALL	.CLRCO	CLEAR CONSOLE INPUT
	LXI	D,2048
	LXI	H,CDATA
FILL0	MVI	M,0
	DCX	D
	INX	H
	MOV	A,D
	ORA	E
	JNZ	FILL0
	JMP	ELSE.H
*
*  SORT OUT WHICH KEY WAS PRESSED
SORT	LXI	H,SELCHR
S1	CPI	'S'	F1 - First Character
	JNZ	S2
	XRA	A
	MOV	M,A
	JMP	CURRST
S2	CPI	'T'	F2 - Next Character
	JNZ	S3
	MOV	A,M	GET SELECTED CHAR #
	INR	A
	ANI	127
	MOV	M,A
	JMP	CURRST
S3	CPI	'U'	F3 - Prior Character
	JNZ	S4
	MOV	A,M	GET SELECTED CHAR #
	DCR	A
	ANI	127
	MOV	M,A
	JMP	CURRST
S4	CPI	'V'	F4 - Move forward 16 characters
	JNZ	S5
	MOV	A,M	GET SELECTED CHAR #
	ADI	16
	ANI	127
	MOV	M,A
	JMP	CURRST
S5	CPI	'W'	F5 - Revert to previous version of character
	JNZ	S6
	LXI	H,CREVERT  Get Revert version
	CALL	GETHL
	JMP	SHOW

S6	CPI	'J'	TEST FOR ERASE
	JNZ	S7
	LHLD	P.CDATA DATA #1
	MVI	A,16
S6A	MVI	M,0	
	INX	H
	DCR	A
	JNZ	S6A	
	JMP	SHOW
S7	CPI	'R'	TEST FOR BLUE
	JNZ	S8
	LXI	H,CURSTYP
	MOV	A,M
	XRI	1	FLIP BIT
	MOV	M,A
	JZ	S7A	ZERO = UNDERLINE CURSOR
	CALL	$TYPTX
	DB	ESC,'x','4'+200Q
	JMP	CLEAR
S7A	CALL	$TYPTX	ONE = BLOCK CURSOR
	DB	ESC,'y','4'+200Q
	JMP	CLEAR	NOT USED - GO ON
S8	CPI	'P'	TEST FOR BLUE
	JNZ	S9
	MVI	A,2
	STA	HMODE
	CALL	$TYPTX
	DB	ESC,'E',NL,NL,'ENTER INPUT',200Q
	CALL	GETFN
	LXI	H,FILE
	LXI	D,DEFAULT
	MVI	A,1
	SCALL	.OPENR
	JC	FLERR
	LXI	D,FDATA
	LXI	B,1536	READ 5 BLOCKS
	MVI	A,1
	SCALL	.READ
	JC	FLERR
	MVI	A,1
	SCALL	.CLOSE
	JC	FLERR
	CALL	$TYPTX
	DB	NL,NL,'INPUT FILE NOW LOADED',200Q
	CALL	EXPAND
	JMP	CLEAR
S9	CPI	'Q'	TEST FOR RED
	JNZ	ELSE.H
	MVI	A,2
	STA	HMODE
	CALL	$TYPTX
	DB	ESC,'E',NL,NL,7,'ENTER OUTPUT',200Q
	CALL	GETFN
	LXI	H,FILE
	LXI	D,DEFAULT
	MVI	A,1
	SCALL	.OPENW
	JC	FLERR
	CALL	SQUEEZE
	LXI	D,FDATA
	LXI	B,1536	WRITE 5 BLOCKS
	MVI	A,1
	SCALL	.WRITE
	JC	FLERR
	MVI	A,1
	SCALL	.CLOSE
	JC	FLERR
	CALL	$TYPTX
	DB	NL,NL,'OUTPUT DUMPED TO FILE',200Q
	JMP	CLEAR
SORTK	SCALL	.CLRCO
	LDA	CLINE
	MOV	C,A
	LDA	CCOL
	MOV	B,A
	LDA	CHAR3

* CHECK FOR KEYPAD KEYS

	CPI	'q'	DOWNLEFT
	JNZ	K2
	CALL	GODOWN
	CALL	GOLEFT
	JMP	CURSET
K2	CPI	'r'	DOWN
	JNZ	K3
	CALL	GODOWN
	JMP	CURSET
K3	CPI	's'	DOWNRIGHT
	JNZ	K4
	CALL	GODOWN
	CALL	GORIGHT
	JMP	CURSET
K4	CPI	't'	LEFT
	JNZ	K5
	CALL	GOLEFT
	JMP	CURSET
K5	CPI	'u'	HOME
	JZ	CURRST0	 (home cursor but don't save character into Revert buf)
K6	CPI	'v'	RIGHT
	JNZ	K7
	CALL	GORIGHT
	JMP	CURSET
K7	CPI	'w'	UPLEFT
	JNZ	K8
	CALL	GOUP
	CALL	GOLEFT
	JMP	CURSET
K8	CPI	'x'	UP ARROW
	JNZ	K9
	CALL	GOUP
	JMP	CURSET
K9	CPI	'y'	UPRIGHT
	JNZ	K0
	CALL	GOUP
	CALL	GORIGHT
	JMP	CURSET

K0	CPI	'p'	Keypad '0' -- Copy Character into Buffer
	JNZ	KDOT
	LXI	H,CBUFFER Save character data into CBUFFER
	CALL	SAVEHL
	PUSH	B
	LDA	SELCHR
	STA	CUTCHAR
	CALL	SHOWBUF Show which character is in the Clipboard
	POP	B
	JMP	CURSET

KDOT	CPI	'n'	Keypad '.'
	JNZ	KENT
	LXI	H,CBUFFER Get character data from CBUFFER
	CALL	GETHL
	JMP	SHOW

KENT	CPI	'M'	Keypad ENTER
	JNZ	CLEAR
	MVI	A,2
	STA	HMODE
	CALL	$TYPTX
	DB	ESC,'E',ESC,'Y',44,32,ESC,'G'
	DB	'Go directly to character -> '
	DB	ESC,'F'+200Q
$ENT	SCALL	.SCIN
	JC	$ENT
	STA	SELCHR
	JMP	CURRST

*
*	Cursor movement routines
*
GOUP	MOV	D,A
	DCR	C	DECREMENT LINE#
	MOV	A,C	DECR. LINE #
	CPI	4	TOP OF BOX
	MOV	A,D	RESTORE A
	RNC
	MVI	C,4
	RET

GOLEFT	MOV	D,A
	DCR	B	COLUMN# -= 2
	DCR	B
	MOV	A,B
	CPI	36
	MOV	A,D	RESTORE A
	RNC
	MVI	B,36
	RET

GORIGHT MOV	D,A	SAVE A
	INR	B
	INR	B
	MOV	A,B
	CPI	51	RIGHT OF BOX
	MOV	A,D	RESTORE A
	RC
	MVI	B,50
	RET

GODOWN	MOV	D,A	SAVE A
	INR	C	COLUMN++
	MOV	A,C
	CPI	16	BOTTOM OF BOX
	RC
	MVI	C,15
	RET

CURSET	LXI	H,CLINE
	MOV	M,C
	INX	H
	MOV	M,B
	CALL	POSCUR		Move cursor to line C, column B

	LDA	HMODE
	ORA	A
	JNZ	SHOW		Display character if not already onscreen
	JMP	CLEAR

*
* GETHL -- Get character data from buffer at (HL)
*
GETHL	XCHG		Put buffer into DE
	LHLD	P.CDATA Address of character data
	PUSH	B	Save B,C
	MVI	C,16
GETHL1	LDAX	D	Get byte from buffer
	MOV	M,A	Save into character
	INX	D
	INX	H
	DCR	C
	JNZ	GETHL1
	POP	B	Restore B,C
	RET
*
* SAVEHL -- Save character data into buffer at (HL)
*
SAVEHL	XCHG		Put DE into HL
	LHLD	P.CDATA (HL) is character data
	PUSH	B	Save B,C
	MVI	C,16
SAVEHL1	MOV	A,M	Get one byte from character
	STAX	D	Save into buffer
	INX	H
	INX	D
	DCR	C
	JNZ	SAVEHL1
	POP	B	Restore B,C
	RET

*
*  FLIP BIT IN CHARACTER AT CURSOR LOCATION
*
SPBAR	LHLD	P.CDATA -> TO DATA ARRAY
	LDA	CCOL	CURSOR COLUMN
	MOV	B,A	SAVE COLUMN
	SUI	36
	ANA	A	CLEAR CARRY
	RAR		/2
	CALL	$DADA
* SELECT MASK FROM LINE
	LDA	CLINE	CURSOR LINE
	MOV	C,A	SAVE LINE
	SUI	4	TOP LINE
	CPI	6	MAY BE 0 -> 12
	JC	BT1
* USE SECOND BYTE OF DATA
	PUSH	PSW
	MVI	A,8	2ND HALF OFFSET
	CALL	$DADA
	POP	PSW
	SUI	6	REVISE MASK POINTER
* USE FIRST BYTE OF DATA
BT1	PUSH	H	ADDRESS OF CURRENT DATA
	LXI	H,MASKS
	CALL	$DADA
	MOV	A,M	GET BIT MASK
	MOV	D,A	SAVE MASK
	POP	H	RESTORE DATA ADDRESS
	XRA	M	TOGGLE BIT
	MOV	M,A	RETURN MODIFIED BYTE
	ANA	D	EXAMINE THIS BIT
	JZ	BIT0
	ORI	1
BIT0	CALL	DODOT
	CALL	$TYPTX
	DB	ESC,'D'+200Q
	JMP	CLEAR
*
* CURRST - Reset the cursor to the center of character. Also save the
*	   current version of the character in the Revert buffer.
*
CURRST	CALL	FINDADR 	Compute P.CDATA, address of this char's data
	LXI	H,CREVERT
	CALL	SAVEHL	
CURRST0	LXI	H,CLINE SET CURSOR TO CENTER
	MVI	M,9	    OF CHARACTER
	INX	H
	MVI	M,42
SHOW	EQU	*
*
*  SHOW THE SELECTED CHARACTER
*
*	INPUTS:
*	SELCHR IS SELECTED CHARACTER #
*
*	OUTPUTS:
*	SHOWS CHARACTER IN CENTER OF SCREEN
*
*
*	BUILD BOX FOR CHARACTER DISPLAY
	LDA	HMODE
	ORA	A
	JZ	SHOW1		CHAR. BACKGROUND ALREADY ON SCREEN IF HMODE==0
	XRA	A
	STA	HMODE		SET HMODE = 0

	CALL	$TYPTX
	DB	ESC,'E',ESC,'F'
	DB	ESC,'Y',35,66,'fababababababababac',200Q
	MVI	C,4
	MVI	D,12
SHOW0	MVI	B,34
	CALL	POSCUR
	MVI	A,'b'
	SCALL	.SCOUT
	MVI	B,52
	CALL	POSCUR
	SCALL	.SCOUT
	INR	C		GO TO NEXT LINE
	DCR	D		COUNT LINES DOWN
	JNZ	SHOW0
	CALL	$TYPTX
	DB	ESC,'Y',48,66,'eababababababababad',200Q
	CALL	SHOWBUF
	JMP	SHOWGO
*
*	Character display already on screen -- just clear it
*
SHOW1	CALL	$TYPTX		GO TO H19 GRAPHICS MODE
	DB	ESC,'F'+200Q
	MVI	C,4
	MVI	D,12
SHOW1A	MVI	B,35
	CALL	POSCUR
	CALL	$TYPTX
	DB	ESC,'K'+200Q
	MVI	B,52
	CALL	POSCUR
	MVI	A,'b'
	SCALL	.SCOUT
	INR	C
	DCR	D
	JNZ	SHOW1A

SHOWGO	CALL	DOBYTS
	LHLD	CLINE		Restore cursor position
	MOV	C,L		L = LINE #   -> C
	MOV	B,H		H = COLUMN # -> B
	CALL	POSCUR
	JMP	CLEAR

* Show which character is currently in the clipboard
*
SHOWBUF PUSH	B
	PUSH	H
	PUSH	D
	CALL	$TYPTX
	DB	ESC,'j',ESC,'G',ESC,'Y5',32,'Character in Clipboard:',32+80H
	LDA	CUTCHAR
	CPI	255
	JNZ	SHOWB1
	CALL	$TYPTX
	DB	'Non','e'+80H
	JMP	SHOWB2
SHOWB1	CALL	DISPCH
SHOWB2	CALL	$TYPTX
	DB	ESC,'k'+80H
	POP	D
	POP	H
	POP	B
	RET

*  ANYTHING ELSE SHOW HELP INSTRUCTIONS
ELSE.H	LXI	H,HMODE
	MOV	A,M
	CPI	1
	JZ	CLEAR	Help already on screen

	MVI	M,1	Put help on screen
	CALL	$TYPTX
	DB	ESC,'E',ESC,'G'
	DB	'8 X 12 CHARACTER GENERATOR 09/11/89',NL
	DB	'Copyright 1982, 1985, 1989 Lindley Systems',NL
	DB	'4257 Berwick Place, Woodbridge VA 22192',NL,NL
	DB	'HELP INSTRUCTIONS:',NL
	DB	'FUNCTION KEYS:',TAB,'f1',TAB,'First character',NL
	DB	TAB,TAB,'f2',TAB,'Next character',NL
	DB	TAB,TAB,'f3',TAB,'Prior character',NL
	DB	TAB,TAB,'f4',TAB,'Move up 16 characters',NL
	DB	TAB,TAB,'f5',TAB,'Revert to last version of character',NL
	DB	TAB,TAB,'ERASE',TAB,'Blank out character',NL
	DB	TAB,TAB,'BLUE',TAB,'Input from disk file',NL
	DB	TAB,TAB,'RED',TAB,'Output to disk file',NL
	DB	TAB,TAB,'WHITE',TAB,'Underline/Block cursor',NL
	DB	'Pad keys:',TAB,'ARROWS',TAB,'Move cursor (diagonals also)',NL
	DB	TAB,TAB,'ENTER',TAB,'Go to character',NL
	DB	TAB,TAB,'HOME',TAB,'Restore same character',NL
	DB	TAB,TAB,'0',TAB,'Copy Character to Clipboard',NL
	DB	TAB,TAB,'.',TAB,'Copy Clipboard to Character',NL
	DB	'Space bar:',TAB,'Reverse dot at cursor',NL
	DB	'Control-C:',TAB,'Exit program',NL
	DB	'Any other key:',TAB,'Show help instructions'
	DB	ESC,'j',ESC,'Y8',32,ESC,'K',32,32,32,32,32
* Each of these labels must have seven characters:
	DB	ESC,'pFirst',ESC,'q',32,32,32
	DB	ESC,'pNext',ESC,'q',32,32
	DB	ESC,'pPrior',ESC,'q',32,32,32
	DB	ESC,'p+16',ESC,'q',32,32
	DB	ESC,'pRevert',ESC,'q',32
	DB	32,ESC,'pErase',ESC,'q',32
	DB	32,32,ESC,'pRead',ESC,'q',32,32,32
	DB	ESC,'pWrite',ESC,'q',32,32
	DB	ESC,'pCursor',ESC,'q',ESC,'k'
	DB	ESC,'F',ENL
CLEAR	EQU	*	GET CONSOLE INPUT
$1	SCALL	.SCIN
	JC	$1
	MOV	B,A
	LDA	HMODE
	ORA	A	A = 1 IF HELP DISPLAYED
	MOV	A,B	CHARACTER BACK IN (A)
	JNZ	TRYESC	IF A <> 0, DON'T LOOK FOR SPACE BAR

	CPI	' '	SPACE BAR TO FLIP DOT
	JZ	SPBAR

TRYESC	CPI	ESC	TEST FOR VALID INPUT SEQUENCE
	JNZ	ELSE.H
$2	SCALL	.SCIN
	JC	$2
	CPI	'?'
	JNZ	SORT
$3	SCALL	.SCIN
	JC	$3
	STA	CHAR3
	JMP	SORTK
CCXIT	CALL	$TYPTX
	DB	ESC,'E',NL,NL
	DB	'EXIT CHARACTER GENERATOR',ESC,'y1',ESC,'x1',ESC,'y4',ENL
OKXIT	CALL	$TYPTX
	DB	ESC,'G'+200Q	EXIT GRAPHICS MODE
	XRA	A		NORMAL RETURN
	SCALL	.EXIT					    

*
DOBYTS	EQU	*
*
*	INPUTS:
*	SELCHR IS SELECTED CHARACTER #
*	C	SCREEN LINE    (BITS)
*	B	SCREEN COLUMN  (BYTES)
*
*	OUTPUTS:
*	MATRIX OF
*	6 COLUMNS OF 12 DOTS/BLANKS ON SCREEN
*
	CALL	$SAVALL
	CALL	$TYPTX
	DB	ESC,'Y"',32,ESC,'x5'
	DB	ESC,'GNow on Character',32+80H
	LDA	SELCHR
	CALL	DISPCH
	CALL	FINDADR Compute P.CDATA and put in HL
	MVI	C,9	START OF TOP
	MVI	B,36	LEFT COLUMN
	MVI	D,50	COLUMN END MARK
	MVI	E,3	END OF TOP - 1
	CALL	HALF
	MVI	B,36	LEFT COLUMN
	MVI	C,15	START OF BOTTOM
	MVI	E,9	END OF TOP -1
	CALL	HALF
	CALL	$TYPTX
	DB	ESC,'y5',ENL
	JMP	$RSTALL

* COMPUTE DATA ARRAY CHARACTER ADDRESS
FINDADR LDA	SELCHR	CHARACTER VALUE
	LXI	D,16	MULTIPLIER
	CALL	$MU86	RESULT -> H,L
	XCHG		(D,E) -> DATA OFFSET
	LXI	H,CDATA -> DATA ARRAY
	DAD	D
	SHLD	P.CDATA POINT TO CURRENT CHAR DATA
	RET

* LOOP TO DISPLAY A COLUMN OF DOTS
*	(H,L) -> CHARACTER DATA
*
HALF	EQU	*
C.TEST	MOV	A,D	COLUMN TEST
	CMP	B
	RC		ALL DONE
	MOV	A,M	COLUMN DATA
	RRC
	RRC
	MOV	M,A
L.TEST	MOV	A,E	LINE TEST
	CMP	C
	JNC	L.DONE
	MOV	A,M	GET DATA BYTE
	CALL	DODOT
	RRC
	MOV	M,A	SAVE WORKING BYTE
	DCR	C	LINE COUNTER
	JMP	L.TEST
L.DONE	INX	H	NEXT DATA
	INR	B	MOVE TWO COL.
	INR	B
	MOV	A,E	RESTORE LINE
	ADI	6
	MOV	C,A
	JMP	C.TEST
*
*
DODOT	EQU	*
*
*	INPUTS:
*	C	SCREEN LINE
*	B	SCREEN COLUMN
*	A	DATA IN HIGH BIT
*
*	OUTPUTS:
*	DOT/SPACE ON SCREEN
*
	PUSH	PSW
	PUSH	H
	ANI	1	BIT TEST
	MVI	A,' '	ASSUME CLEAR
	JZ	DO.1
	MVI	A,'^'	DOT ON SCREEN
DO.1	CALL	POSCUR
	SCALL	.SCOUT	; OUTPUT CHARACTER IN (A)
	POP	H
	POP	PSW
	RET
**
*	GET FILE NAME
GETFN	XRA	A
	MVI	B,000Q	LINE MODE, ECHO
	MVI	C,201Q
	SCALL	.CONSL
	CALL	$TYPTX
	DB	' FILE NAME -> ',ESC,71,200Q
	LXI	H,FILE-1
G1	SCALL	.SCIN
	JC	G1
	INX	H
	MOV	M,A
	CPI	NL
	JNZ	G1
	MVI	M,0	FILE NAME END
	XRA	A
	MVI	B,201Q	CHAR MODE, NO ECHO
	MVI	C,201Q
	SCALL	.CONSL
	RET
**
*
SQUEEZE EQU	*
	LXI	H,FDATA
	SHLD	POUT
	LXI	H,CDATA
	SHLD	PIN	SAVE DATA POINTER
	MVI	B,128
SQL	CALL	SQHALF
	CALL	SQHALF
	DCR	B
	JNZ	SQL
	RET
SQHALF	MVI	C,8	BYTES IN 1/2 CHAR
	MVI	E,8
SQH1	CALL	IPUT
	MVI	D,6
SQH2	DAD	H
	DCR	E
	JNZ	SQH3
	MVI	E,8
	CALL	OPUT
SQH3	DCR	D
	JNZ	SQH2
SQH4	DCR	C
	JNZ	SQH1
	RET
**
*
EXPAND	EQU	*
	LXI	H,CDATA
	SHLD	POUT
	LXI	H,FDATA
	SHLD	PIN
	MVI	B,128
EXL	CALL	EXHALF
	CALL	EXHALF
	DCR	B
	JNZ	EXL
	RET
EXHALF	MVI	C,6	BYTES PER 1/2 CHAR
	MVI	E,6
EXH1	CALL	IPUT	SAVE SHIFTED BITS
	MVI	D,8
EXH2	DAD	H
	DCR	E
	JNZ	EXH3
	MVI	E,6
	MOV	A,H
	RLC
	RLC
	MOV	H,A
	CALL	OPUT
EXH3	DCR	D	SHIFT LEFT
	JNZ	EXH2
EXH4	DCR	C
	JNZ	EXH1
	RET
IPUT	PUSH	H
	LHLD	PIN
	MOV	A,M
	INX	H
	SHLD	PIN
	POP	H
	MOV	L,A
	RET
OPUT	PUSH	H
	MOV	A,H
	LHLD	POUT
	MOV	M,A
	INX	H
	SHLD	POUT
	POP	H
	RET
**
*	FILE ERROR
FLERR	CALL	$TYPTX
	DB	NL,'FILE ERROR - TRY AGAIN',ENL
	JMP	CLEAR
**
* SAVE ALL REGISTERS EXCEPT A,F
*
SAVE	SHLD	SAVEX
	XTHL	PUSH H
	PUSH	D
	PUSH	B
	PUSH	H
	LHLD	SAVEX
	RET
SAVEX	DW	0
**
* RESTORE ALL REGISTERS EXECPT A,F
*
RESTORE POP	B
	POP	D
	POP	H
	RET
**
* POSCUR -- POSITION CURSOR AT LINE (C), COLUMN (B)
*
*  USES: NONE
POSCUR	PUSH	PSW
	MVI	A,ESC
	SCALL	.SCOUT
	MVI	A,'Y'
	SCALL	.SCOUT
	MOV	A,C	GET LINE #
	ADI	32
	SCALL	.SCOUT
	MOV	A,B	GET COLUMN #
	ADI	32
	SCALL	.SCOUT
	POP	PSW
	RET
*
* DISPCH: Display the ASCII value of a character, and the
* character itself: <a>
*
*	Input: Character in A
DISPCH	MVI	D,0	NORMAL CHARACTERS
	MOV	C,A	SAVE CHARACTER IN C
	CPI	127
	JZ	EQ127
	CPI	32
	JNC	GT31
EQ127	INR	D	GRAPHIC CHARACTERS
	ADI	95
	ANI	7FH
GT31	PUSH	D
	STA	DISCHR	SHOW SELECTED CHARACTER
	MVI	B,0	Character in BC
	LXI	H,DISNUM
	MVI	A,3
	CALL	$UDD	UNPACK DECIMAL DIG.
	CALL	$TYPTX
DISNUM	DB	'XXX <',80H
	POP	D
	DCR	D
	JNZ	DISDO
	CALL	$TYPTX
	DB	ESC,'F'+200Q ENTER GRAPHICS MODE
DISDO	CALL	$TYPTX
DISCHR	DB	0,ESC,'F>',ENL
	RET
*
**
*	DATA SPACE
CURSTYP DB	0	Underline cursor
SQCNT	DW	0
PIN	DW	0
POUT	DW	0
HMODE	DB	0	On Screen: =0 if Character; =1 if Help; =2 if Other
CLINE	DB	10
CCOL	DB	36
SELCHR	DB	32	SELECTED CHARACTER
HISEL	DB	0	ALWAYS ZER0
CHAR3	DB	0	KEY PAD ID

CUTCHAR DB	255	Character in Clipboard (default: none)
* "Clipboard" for character:
CBUFFER DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

* Place to save "Revert" version of current character
CREVERT	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

UNITNO	DS	1
DEFAULT DB	'SY0',0,0,0
FILE	DS	16
MASKS	DB	200Q,100Q,40Q,20Q,10Q,4
P.CDATA DW	CDATA	CURRENT OUTPUT POINTER 
*
	DB	'QZ'
FDATA	EQU	*
CDATA	EQU	*+1536
*
**
*
	END	GOTOIT
