********************************************************
* PRGR - PROGRAM TO SEND GRAPHICS CHARACTERS
* FROM DISK FILE TO LISTING DEVICE LP:.
* 16-JUN-85	UPDATE FOR HDOS OPERATION
*
YES	EQU	0
NO	EQU	1
*
* START PRINTER SELECTION
MX	EQU	YES	; EPSON/STAR
ML82	EQU	NO	; MICROLINE 82/83
ML84	EQU	NO	; MICROLINE 84
ML92	EQU	NO	; MICROLINE 92/93
NC	EQU	NO	; NEC-8023, CITOH-8510
MPI	EQU	NO	; MPI 88G 99G 150
* END PRINTER SELECTION
*
ML	EQU	ML82+ML84+ML92-2
ML8292	EQU	ML82+ML92-1
ML8492	EQU	ML84+ML92-1
MXML84	EQU	MX+ML84-1
COUNT	EQU	MX+ML84+NC-2
MXCPM	EQU	1
ML82CPM EQU	1
ML84CPM EQU	1
ML92CPM EQU	1
NCCPM	EQU	1
MPICPM	EQU	1
MLCPM	EQU	1
	LON	IC
	XTEXT	HOSDEF
	ORG	USERFWA
BEGIN	LXI	H,0	ZERO OFSET FROM THE
	DAD	SP	  STACK POINTER
	LXI	D,FNAME1-1
L1	INX	H	GET FILE NAME
	INX	D
	MOV	A,M
	STAX	D
	CPI	0	COMMAND LINE DELIMITED BY A NULL
	JNZ	L1
	XCHG
	MVI	M,0Q
	INX	H
	MVI	M,200Q
	LXI	H,BEGIN
	SPHL
	MVI	A,3	CONTROL C HANDLING
	LXI	H,CCINT
	SCALL	.CTLC
	CALL	$TYPTX
	DB	NL,'File ',200Q
	LXI	H,FNAME1
	SCALL	.PRINT
	LXI	D,DFBLK1
	LXI	H,FNAME1
	MVI	A,1
	SCALL	.OPENR
	JC	FILEERR
	CALL	$TYPTX
	DB	' is being printed.',NL,ENL
	LXI	D,DFBLK2
	LXI	H,FNAME2
	MVI	A,2
	SCALL	.OPENW
	JC	FILEERR
	CALL	$TYPTX
	DB	'LP: IS OPEN',ENL
*  LOOP FOR READING FILE SECTORS
LOOP	MVI	A,1	CHANNEL ONE
	LXI	D,BUFF
	LXI	B,256
	MVI	A,1
	SCALL	.READ
	JNC	READOK
FERR	CPI	1	END OF FILE ?
	JNE	FILEERR
	JMP	XIT	ALL DONE
READOK	LXI	D,BUFF
	MVI	B,0
IL	LDAX	D
	MOV	C,A
	CPI	0
	JZ	XIT
	SCALL	.SCOUT
	PUSH	B
	PUSH	D
	PUSH	H
	CALL	GRCHAR
	POP	H
	POP	D
	POP	B
	INX	D
	DCR	B
	JZ	LOOP	END OF BLOCK
	JMP	IL
* D,E -> BYTE TO WRITE
LGOUT	PUSH	B
	PUSH	D
	PUSH	H
	LXI	H,DUMMY
	MOV	M,C
	XCHG
	LXI	B,1
	MVI	A,2	CHANNEL 2
	SCALL	.WRITE
	POP	H
	POP	D
	POP	B
	RET
*
XIT	MVI	A,1
	SCALL	.CLOSE
	MVI	A,2
	SCALL	.CLOSE
CCINT	MVI	A,0
	SCALL	.EXIT
FILEERR PUSH	PSW	SAVE ERROR CODE
	LXI	H,ERRORA
	SCALL	.PRINT
	POP	PSW
	MVI	H,BELL	BELL WITH MESSAGE
	SCALL	.ERROR
	XRA	A
	SCALL	.EXIT
ERRORA	DB	NL,'ERROR -',' '+200Q
DFBLK1	DB	'SY0',0,0,0
DFBLK2	DB	'SY0',0,0,0
SECTOR	DW	0
FNAME1	DS	40
FNAME2	DB	'LP:',0,200Q
*
	XTEXT	UPCUL1
DUMMY	DB	0
BUFF	DS	1	BUFFER AREA AT END
	END	BEGIN
